.586
.model flat, stdcall
option casemap:none

DialogProc	PROTO	:DWORD, :DWORD, :DWORD, :DWORD

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\wsock32.inc
include \masm32\include\comctl32.inc
include inc.inc
;include sockets.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\wsock32.lib
includelib \masm32\lib\comctl32.lib

.data?

	  szmess	       db 200 dup (?)
	  szfrom	       db 200 dup (?)
	  szto		       db 200 dup (?)
	  szlog 	       db 200 dup (?)
	  szpass	       db 200 dup (?)
	  szserv	       db 200 dup (?)
	  szsubj	       db 200 dup (?)
	  base64log	       db 200 dup (?)
	  base64pass	       db 200 dup (?)
.data

spec	dd 0
all_ok_msg	       db "Message sent",0
	  cantconnects	       db "Can't connect to host",0
	  cantfind	       db "Cant find server. Check Connection",0
	  buf db 100h dup (0)
.code

start:

jmp next___

  
  get_data proc 
	  mov	     edi,OFFSET buf
	  mov	     ecx,100h
  _loop:     
	  jecxz      _err
		     
	  push	     ecx
	  push	     ecx
	  invoke     recv,ebx,edi,ecx,0
	  pop	     ecx
	  pop	     ecx
		     
	  inc eax
	  je	    _err
	  dec eax
		     
	  add	     edi,eax
	  sub	     ecx,eax
		     
	  cmp	     byte ptr [edi-1],10
	  je	     _ok
		     
  _test:     
	  test	     eax,eax
	  jnz	     _loop
  _err:      
	  xor	     eax,eax
	  jmp	     _end
  _ok:	     
		     
	  cmp	     byte ptr [buf],'2'
	  jz	     _a
		     
	  cmp	     byte ptr [buf],'3'
	  jnz	     _err
  _a:	     
	  inc	     eax
	  inc	     edi
	  mov	     byte ptr [edi],0
		     
  _end:      
		     
	  ret	     
 get_data endp	  
		     

   Send_String proc lpStr:LPSTR
	     
	  invoke     lstrlen,ADDR lpStr
	  invoke     send,ebx,ADDR lpStr,eax,0
	  ret	     
  Send_String endp	  



next___:
	invoke	GetModuleHandle,NULL
	invoke	DialogBoxParam,eax,IDD_DIALOG1,NULL,ADDR DialogProc,NULL
	.IF eax==0
		invoke	ExitProcess,NULL
	.ENDIF

DialogProc	proc	hwnddlg:HWND, msg:UINT, wparam:WPARAM, lparam:LPARAM
	push	ebx
	push	esi
	push	edi
	
	.IF msg==WM_COMMAND
		je	wmcommand
	.ELSEIF msg==WM_CLOSE
		jz	wmclose
	.ENDIF
	xor	eax,eax
	jmp	finish
wmcommand:
	mov	eax,wparam
	shr	eax,16
	cmp	eax,BN_CLICKED
	jne	processed
	push	hwnddlg
	call	GetInfoAndSend
	jmp	processed
wmclose:
	invoke	EndDialog,hwnddlg,0
processed:
	mov	eax,1
finish:
	pop	edi
	pop	esi
	pop	ebx
	ret
DialogProc	endp
		     
GetInfoAndSend	proc	hwnd:HWND
	mov	ebx,7
	lea	esi,szmess
	mov	eax,IDC_EDIT1
getdataloop:
	push	eax
	push	esi
	invoke	GetDlgItemText,hwnd,eax,esi,200
	
	pop	esi
	pop	eax
	inc	eax
	add	esi,200
	dec	ebx
	jnz	getdataloop
	
	lea	     eax,szsubj
	  push	     eax
	  lea	     eax,szserv
	  push	     eax
	  lea	     eax,szpass
	  push	     eax
	  lea	     eax,szlog
	  push	     eax
	  lea	     eax,szto
	  push	     eax
	  lea	     eax,szfrom
	  push	     eax
	  lea	     eax,szmess
	  push	     eax
	  call	     SendMail
	  ret
	  
	  szEHLO	       db "EHLO server",13,10,0
	  szAUTHLOGIN	       db "AUTH LOGIN",13,10,0
	  szMAILFROM	       db "MAIL FROM:<",0
	  szRCPTTO	       db "RCPT TO:<",0
	  szSKOBKA	       db ">",13,10,0
	  szDATA	       db "DATA",13,10,0
	  szSubject	       db "Subject: ",0
	  szEnd 	       db 13,10,".",13,10,0
	  szQuit	       db "QUIT",13,10,0
	  saddr      sockaddr_in <>
	  wsad1      WSADATA <>
	  
GetInfoAndSend	endp 
		     
SendMail	proc	pszmess:DWORD,pszfrom:DWORD,pszto:DWORD,pszlog:DWORD,pszpass:DWORD,pszserv:DWORD,pszsubj:DWORD
	  
	
	  lea	     ebx,base64log
	  invoke     lstrlen,pszlog
	  push		eax
	  push		ebx
	  mov	eax,dword ptr [pszlog]
	  push 	eax
	  call	Base64Encode
	  add	     ebx,200
	  invoke     lstrlen,pszpass
	  push		eax
	  push		ebx
	  mov	eax,dword ptr [pszpass]
	  call	Base64Encode
		     
	  invoke     WSAStartup,202h,ADDR wsad1		     
	  invoke     socket,2,1,0
	  or	     eax,eax
	  jz	     nosock
	  mov	     ebx,eax
		     
	  invoke     gethostbyname,pszserv
	  test	     eax,eax
	  jz	     cantfinds
	  mov	     eax,[eax+0ch]
	  mov	     eax,[eax]
	  mov	     eax,[eax]
		     
	  mov	     dword ptr [saddr.sin_addr],eax
		     
	  mov	     word  ptr [saddr.sin_family],AF_INET
	  mov	     ax,25
	  xchg	     ah,al
	  mov	     word ptr [saddr.sin_port],ax
		     
	  invoke     connect,ebx,ADDR saddr,sizeof sockaddr_in
	  test	     eax,eax
	  jnz	     cantconnect
		     
	  call	     get_data
	  test	     eax,eax
	  jz	     errrecv
		     
	  mov	     eax,OFFSET szEHLO
	  call	     sendNrecv
		     
	  mov	     eax,OFFSET szAUTHLOGIN
	  call	     sendNrecv
		     
	  lea	     eax,base64log
	  push	eax
	  call	Send_String
	  mov	     eax,OFFSET szEnd+3
	  call	     sendNrecv
		     
	  lea	     eax,base64pass
	  push	eax
	  call    Send_String
	  mov	     eax,OFFSET szEnd+3
	  call	     sendNrecv
	
	 push OFFSET szMAILFROM
	 
	  call    Send_String
	  
	  push	pszfrom
	  
	  call    Send_String
	  mov	     eax,OFFSET szSKOBKA
	  call	     sendNrecv
	push OFFSET szRCPTTO
	  call    Send_String
	  push pszto
	  call    Send_String
	  mov	     eax,OFFSET szSKOBKA
	  call	     sendNrecv
	 push	OFFSET szDATA
	  call    Send_String
          push OFFSET szSubject		     
	  call    Send_String
	  push pszsubj
	  call    Send_String
	  mov	     eax,OFFSET szEnd+3
	  call	     sendNrecv		     
	push pszmess
	  call    Send_String
		     
	  mov	     eax,OFFSET szEnd
	  call	     sendNrecv
		     
	  mov	     eax,OFFSET szQuit
	  call	     sendNrecv
		     
	  invoke     MessageBox,0,ADDR all_ok_msg,ADDR all_ok_msg,0
		     
  closesock: 
	  invoke     closesocket,ebx
  nosock:    
	  invoke     WSACleanup
	  ret	     
		     
	  
  cantfinds: 
	  invoke     MessageBox,0,OFFSET cantfind,0,0
	  jmp	     nosock
  cantconnect: 
	  invoke     MessageBox,0,OFFSET cantconnects,0,0
	  jmp	     closesock
  errrecv:   
	  invoke     MessageBox,0,OFFSET buf,0,0
	  jmp	     closesock
			     
  sendNrecv: 
  	push eax
	  call    Send_String
		     
	  call	     get_data
	  test	     eax,eax
	  pop	     ecx
	  jz	     errrecv
	  jmp	     ecx
SendMail  endp	  
		     

 Base64Encode proc lpSrc:DWORD,lpDst:DWORD,dwstrlen:DWORD
 	push	esi
 	push	edi
 	push	edx
 	push	ebx
	
		     
	  mov	     esi,lpSrc
	  mov	     edi,lpDst
	  mov	     ebx,dword ptr [dwstrlen]
	  call	     b64encode
		     
	  pop ebx 
	  pop edx 
	  pop edi 
	  pop esi
	  ret	     
  Base64Encode endp	  
		     
		     
  b64:	     
    b64newline:  
	  call	     b64store_crlf
		     
    b64encode:	
    mov	spec,76
    shr	spec,2
    inc	spec
    push	spec						; ebp = length, esi -> src buffer, edi -> dst buffe
	  pop	     edx
		     
    b64outer:    
	  dec	     edx
	  je	     b64newline
	  lodsd      
	  dec	     esi
	  inc	     ebx
	  bswap      eax
	  mov	     ecx,4
		     
    b64inner:    
	  rol	     eax,6
	  and	     al,3Fh
	  cmp	     al,3Eh
	  jb	     b64testchar
	  shl	     al,2
	  mov	    byte ptr [spec],3Eh
	  shl	byte ptr [spec],2
	  add	byte ptr [spec],'A'
	  sub	byte ptr [spec],'+'
	  and	byte ptr [spec], 0FFh
	  sub	al,byte ptr [spec]
		     
    b64testchar: 
	  sub	     al,4
	  cmp	     al,'0'
	  jnl	     b64store
	  add	     al,'A'+4
	  cmp	     al,'Z'
	  jbe	     b64store
	  add	     al,'a'-'Z'-1
		     
    b64store:    
	  stosb      
	  dec	     ebx
	  loopne     b64inner
	  jne	     b64outer
	  mov	     al,'='
	  rep	     stosb
	  xor	     al,al
	  stosb      
	  ret	     
		     
    b64store_crlf: 
	  mov	     ax,0a0dh
	  stosw      
		     
	  ret	     
		     
 end	start